/* $Workfile: OsaMemDbg.h $   $Revision: 5 $    $Modtime: 11/06/03 3:54p $  */
/*******************************************************************************

  Odin TeleSystems Inc.

  OTX Telecom Adapter Driver

  @doc internal

  @module

  @normal Copyright (C) Odin TeleSystems Inc., 1998-2003, All Rights Reserved

*******************************************************************************/

#ifndef OSA_MEM_DBG
#define OSA_MEM_DBG

#if DBG

#include "Api/OsaDef.h"

// Values which is used to fill memory that is not being used (to provoke hard-to-find errors earlier)
#define OSA_NO_MANS_LAND_VAL     0xFD   // Same value Microsoft is using
#define OSA_FREED_BLOCKS_VAL     0xDD   // Same value Microsoft is using
#define OSA_NEW_BLOCKS_VAL       0xCD   // Same value Microsoft is using
#define OSA_NO_MANS_LAND_CB      8

struct OsaMemoryHeader;

struct OsaMemoryHeader {
  size_t            m_cbUserBlock;
  OsaUint32         m_nSequence;
  OsaBool32         m_bDeleted;
  int               m_nLine;
  char              *m_pszFileName;
  OsaMemoryHeader   *m_pNext;
  OsaMemoryHeader   *m_pPrev;
};


#define OSA_EXTRA_MEM_NEEDED (sizeof(OsaMemoryHeader) + 2 * OSA_NO_MANS_LAND_CB)

OsaUint32 OsaMemoryGetCurrentUsage();
void OsaPrintCurrentlyUsed();
void *OsaMakeMemoryHeaderTail(void *pBase, size_t cbUserBlock, char *szFileName, int nLine);
OsaBool32 OsaIsMemoryConstByte(void *pMemory, size_t cbMemory, OsaUint8 nConstValue);
void *OsaIsMemoryValid(void *pUser);
void *OsaUndoMemoryHeaderTail(void *pUser);

#else

// HJ990318 We must allocate one extra byte otherwise the Win98 driver will crash at bootup. I don't know exactly which piece of the code that overwrites its boundaries but I suspect OdVector
// LME990909 This is probably fixed now, I remember there was something we did that we thought could fix it, but I forget exactly what
#define OSA_EXTRA_MEM_NEEDED 4

#endif

#endif
